<?php

namespace xenarabia\postPanel\XF\Repository;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Repository;

class PostsPanelRepo extends Repository
{

    public function getPostCount($user_id)
    {
        $db = \XF::db();

        $postsCount = "SELECT xf_node.node_id, xf_node.title , COUNT(post_id) AS post_count 
                        FROM xf_post 
                        JOIN xf_thread ON xf_post.thread_id = xf_thread.thread_id 
                        JOIN xf_node ON xf_thread.node_id = xf_node.node_id
                        WHERE xf_post.user_id = ? AND 
                            xf_post.message_state = 'visible' AND
                            xf_thread.discussion_state = 'visible' AND
                            xf_node.node_type_id = 'Forum' 
                        GROUP BY xf_node.title
                        ORDER BY post_count DESC";

        $result = $db->fetchAll($postsCount, $user_id);
        return $result;
    }


    public function getThreadCount($user_id)
    {
        $db = \XF::db();

        $threadsCount = 'SELECT xf_thread.node_id, COUNT(xf_thread.thread_id) AS thread_count
                        FROM xf_thread
                        WHERE xf_thread.user_id = ? AND 
                                xf_thread.discussion_state =\'visible\'
                        GROUP BY xf_thread.node_id
                        ORDER BY thread_count DESC';

        $result = $db->fetchAll($threadsCount, $user_id);
        return $result;
    }


    public function grbPostAndThreadCountsForCache($user_id)
    {
        $postCounts = $this->getPostCount($user_id);
        $threadCounts = $this->getThreadCount($user_id);

        // add threads counts to the posts conuts
        foreach ($postCounts as &$postEntry) {

            $postEntry['thread_count'] = 0;

            foreach ($threadCounts as $threadEntry) {
                if ($threadEntry['node_id'] == $postEntry['node_id']) {
                    $postEntry['thread_count'] = $threadEntry['thread_count'];
                }
            }
        }

        return $postCounts;
    }
}
